/*********************************************************
* HotProp Control
* Version: 1.8
* Date: September 1, 2003
* Autor: Michal Mecinski
* E-mail: mimec@mimec.w.pl
* WWW: http://www.mimec.w.pl
*
* Copyright (C) 2002-03 by Michal Mecinski
*********************************************************/

#include "stdafx.h"
#include "HPDynEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


CHPDynEdit::CHPDynEdit(CRect& rcLoc, LPCSTR lpszText, int nLimit, CPoint& ptAct,
	int fFlags, CFont* pFont, CWnd* pParent)
{
	if (Create(WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL | ES_LEFT | fFlags,
		rcLoc, pParent, 1))
	{
		SetFont(pFont);
		SetWindowText(lpszText);
		SetLimitText(nLimit);
		SetFocus();
		int nPos = CharFromPos(ptAct - rcLoc.TopLeft());
		SetSel(nPos, nPos);
	}
	m_bDone = TRUE;
}


BEGIN_MESSAGE_MAP(CHPDynEdit, CEdit)
	ON_CONTROL_REFLECT(EN_KILLFOCUS, OnKillFocus)
END_MESSAGE_MAP()


void CHPDynEdit::OnKillFocus() 
{
	GetOwner()->SendMessage(HPEM_ENDEDIT, m_bDone);
	DestroyWindow();
}

BOOL CHPDynEdit::PreTranslateMessage(MSG* pMsg) 
{
	if (pMsg->message==WM_KEYDOWN)
	{
		switch (pMsg->wParam)
		{
		case VK_ESCAPE:
			m_bDone = FALSE;
		case VK_RETURN:
			AfxGetMainWnd()->SetFocus();
			return TRUE;
		}
	}
	return CEdit::PreTranslateMessage(pMsg);
}

void CHPDynEdit::PostNcDestroy()
{
	delete this;
}
