/*********************************************************
* HotProp Control
* Version: 1.8
* Date: September 1, 2003
* Autor: Michal Mecinski
* E-mail: mimec@mimec.w.pl
* WWW: http://www.mimec.w.pl
*
* You may freely use and modify this code, but don't remove
* this copyright note.
*
* There is no warranty of any kind, express or implied, for this class.
* The author does not take the responsibility for any damage
* resulting from the use of it.
*
* Let me know if you find this code useful, and
* send me any modifications and bug reports.
*
* Copyright (C) 2002-03 by Michal Mecinski
*********************************************************/

#pragma once

#define HPPM_ENDPOP		(WM_USER+1703)	// bDone
#define HPPM_DRAWITEM	(WM_USER+1704)	// nItem, pDrawInfo


class CHPPopList : public CMiniFrameWnd
{
public:
	CHPPopList(CRect& rcRect, int nValue, BOOL bKey, int nItems,
		CFont* pFont, CWnd* pParent);

public:
	struct DrawInfo // used by HPPM_DRAWITEM
	{
		CDC* m_pDC;
		CRect m_rcRect;
	};

protected:
	int m_nItems;
	int m_nValue;
	int m_nReturn;
	CWnd* m_pParent;
	CFont* m_pFont;
	int m_nHot;
	BOOL m_bCapture;
	BOOL m_bLunaXP;
	int m_nHeight;
	BOOL m_bTop;

protected:
	void InvalidateItem(int nPos);

protected:
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnPaint();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnCaptureChanged(CWnd *pWnd);
	afx_msg void OnTimer(UINT nIDEvent);
	DECLARE_MESSAGE_MAP()
};

