// HotPropView.cpp : implementation of the CHotPropView class
//

#include "stdafx.h"
#include "HotProp.h"
#include "HotPropCtrl.h"
#include "HotPropDoc.h"
#include "HotPropView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHotPropView

IMPLEMENT_DYNCREATE(CHotPropView, CView)

BEGIN_MESSAGE_MAP(CHotPropView, CView)
	//{{AFX_MSG_MAP(CHotPropView)
	ON_WM_CHAR()
	//}}AFX_MSG_MAP
	ON_MESSAGE(HPCM_UPDATE, OnHotPropUpdate)
	ON_MESSAGE(HPCM_DRAWCUSTOM, OnHotPropDrawCustom)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHotPropView construction/destruction

CHotPropView::CHotPropView()
{
	// TODO: add construction code here
}

CHotPropView::~CHotPropView()
{
}

BOOL CHotPropView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CHotPropView drawing

void CHotPropView::OnDraw(CDC* pDC)
{
	CHotPropDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CHotPropView diagnostics

#ifdef _DEBUG
void CHotPropView::AssertValid() const
{
	CView::AssertValid();
}

void CHotPropView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CHotPropDoc* CHotPropView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CHotPropDoc)));
	return (CHotPropDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHotPropView message handlers

void CHotPropView::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	CHotPropCtrl& prop = ((CMainFrame*)AfxGetMainWnd())->GetHotProp();
	prop.ProcessKey(nChar);	// pass the key to the prop ctrl
}

void CHotPropView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	CHotPropCtrl& prop = ((CMainFrame*)AfxGetMainWnd())->GetHotProp();

	prop.RemoveAllProps();

	// DEMOS

	prop.AddProp(1, propToggle, "&View demos", 2);
	prop.SetPropToggle(1, "No", "Yes");
	prop.SetProp(1, TRUE);
	prop.SetPropBar(1);

	prop.AddProp(2, propInt, "&Integer demo", 0);
	prop.SetPropLimits(2, 0, 1000);
	prop.SetProp(2, 123);

	prop.AddProp(3, propString, "&String demo", 1);
	prop.SetPropLimit(3, 50);
	prop.SetProp(3, "Example");
	
	prop.AddProp(4, propToggle, "&Toggle demo", 2);
	prop.SetPropToggle(4, "False", "True");
	prop.SetProp(4, TRUE);
	
	prop.AddProp(5, propList, "&List demo", 3);
	CStringArray& arr = prop.GetPropStringArray(5);
	arr.Add("First item");
	arr.Add("Second item");
	arr.Add("Third item");
	arr.Add("Fourth item");
	prop.SetProp(5, 3);

	prop.AddProp(6, propButton, "Simple &button", 1);
	prop.SetProp(6, "Press me!");

	// MISC

	prop.AddProp(10, propString, "Loc&ked item", 1);
	prop.LockProp(10);
	prop.SetProp(10, "You can't change this");

	prop.AddProp(11, propString, "&Disabled item", 1);
	prop.EnableProp(11, FALSE);
	prop.SetProp(11, "Invisible");

	prop.AddProp(12, propToggle, "C&ustom drawn", 2);
	prop.SetPropToggle(12, "Off", "On");
	prop.SetProp(12, TRUE);
	prop.SetCustomProp(12, 1);

	// EXAMPLES

	prop.AddProp(100, propList, "&More examples", 4);
	CStringArray& arrx = prop.GetPropStringArray(100);
	arrx.Add("None");
	arrx.Add("Example 1 - name");
	arrx.Add("Example 2 - locking");
	arrx.Add("Example 3 - custom drawn");
	prop.SetProp(100, 0);
	prop.SetPropBar(100);

	// Example 1

	prop.AddProp(110, propString, "Property &name", 1);
	prop.SetProp(110, "Extra");

	prop.AddProp(111, propInt, "Extra", 4);
	prop.SetProp(111, 1);

	// Example 2

	prop.AddProp(120, propToggle, "&Disabled", 2);
	prop.SetPropToggle(120, "No", "Yes");
	prop.SetProp(120, FALSE);

	prop.AddProp(121, propToggle, "Loc&ked", 2);
	prop.SetPropToggle(121, "No", "Yes");
	prop.SetProp(121, FALSE);
	
	prop.AddProp(122, propString, "&Another property", 4);
	prop.SetProp(122, "This is the second example");

	// Example 3

	prop.AddProp(130, propList, "T&ext orientation", 7);
	CStringArray& arrt = prop.GetPropStringArray(130);
	arrt.Add("Left aligned");
	arrt.Add("Centered");
	arrt.Add("Right aligned");
	prop.SetProp(130, 0);
	prop.SetCustomProp(130, 2);

	prop.AddProp(131, propEnum, "&Color", 8);
	prop.SetPropLimit(131, 6);
	prop.SetProp(131, 0);
	prop.SetCustomProp(131, 3);

	prop.ShowPropsRng(110, 139, FALSE, FALSE);

	prop.Update();
}

// Message handler for HPCM_UPDATE
LRESULT CHotPropView::OnHotPropUpdate(WPARAM nID, LPARAM nValue)
{
	CHotPropCtrl& prop = ((CMainFrame*)AfxGetMainWnd())->GetHotProp();
	CString str;

	switch (nID)
	{
	case 1:
		prop.ShowPropsRng(2, 9, nValue);
		break;

	case 2:
		str.Format("The number is %d", nValue);
		MessageBox(str);
		break;

	case 3:
	case 4:
	case 5:
		str.Format("The string is '%s'", prop.GetPropStr(nID));
		MessageBox(str);
		break;

	case 6:
		MessageBox("The button was pressed");
		break;

	case 100:
		prop.ShowPropsRng(110, 139, FALSE, FALSE);
		if (nValue==1)
			prop.ShowPropsRng(110, 119, TRUE);
		else if (nValue==2)
			prop.ShowPropsRng(120, 129, TRUE);
		else if (nValue==3)
			prop.ShowPropsRng(130, 139, TRUE);
		else
			prop.Update();
		break;

	case 110:
		prop.SetPropName(111, prop.GetPropStr(110));
		break;

	case 120:
		prop.EnableProp(122, !nValue);
		break;

	case 121:
		prop.LockProp(122, nValue);
		break;
	}
	return 0;
}

// Message handler for HPCM_DRAWCUSTOM
LRESULT CHotPropView::OnHotPropDrawCustom(WPARAM nCustom, LPARAM pCustomItem)
{
	CHotPropCtrl& prop = ((CMainFrame*)AfxGetMainWnd())->GetHotProp();

	CHotPropCtrl::CustomItem* pItem = (CHotPropCtrl::CustomItem*)pCustomItem;

	CDC& dc = *pItem->m_pDC;
	CRect rcItem = pItem->m_rcRect;

	switch (nCustom)
	{
	case 1:
		{
			CImageList& imgList = prop.GetImageList();
			imgList.Draw(&dc, 5 + pItem->m_nValue, rcItem.TopLeft(), ILD_TRANSPARENT);
			rcItem.left += 20;
			dc.DrawText(pItem->m_lpszValue, &rcItem, DT_SINGLELINE | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX);
		}
		break;

	case 2:
		{
			dc.MoveTo(rcItem.left, rcItem.top);
			dc.LineTo(rcItem.left, rcItem.bottom);
			dc.MoveTo(rcItem.right, rcItem.top);
			dc.LineTo(rcItem.right, rcItem.bottom);
			rcItem.DeflateRect(4, 0);
			UINT fOrient = pItem->m_nValue;
			dc.DrawText(pItem->m_lpszValue, &rcItem, DT_SINGLELINE | DT_VCENTER | DT_END_ELLIPSIS | DT_NOPREFIX | fOrient);
		}
		break;

	case 3:
		{
			static const COLORREF crArray[6] = {
				RGB(255,0,0), RGB(255,255,0), RGB(0,255,0),
				RGB(0, 255, 255), RGB(0,0,255), RGB(255,0,255)
			};
			dc.FillSolidRect(&rcItem, crArray[pItem->m_nValue]);
		}
		break;
	}
	return 0;
}